install.sh 12 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. blue='\033[0;34m'
  5. yellow='\033[0;33m'
  6. plain='\033[0m'
  7. cur_dir=$(pwd)
  8. # check root
  9. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  10. # Check OS and set release variable
  11. if [[ -f /etc/os-release ]]; then
  12. source /etc/os-release
  13. release=$ID
  14. elif [[ -f /usr/lib/os-release ]]; then
  15. source /usr/lib/os-release
  16. release=$ID
  17. else
  18. echo "Failed to check the system OS, please contact the author!" >&2
  19. exit 1
  20. fi
  21. echo "The OS release is: $release"
  22. arch() {
  23. case "$(uname -m)" in
  24. x86_64 | x64 | amd64) echo 'amd64' ;;
  25. i*86 | x86) echo '386' ;;
  26. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  27. armv7* | armv7 | arm) echo 'armv7' ;;
  28. armv6* | armv6) echo 'armv6' ;;
  29. armv5* | armv5) echo 'armv5' ;;
  30. s390x) echo 's390x' ;;
  31. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  32. esac
  33. }
  34. echo "arch: $(arch)"
  35. os_version=""
  36. os_version=$(grep "^VERSION_ID" /etc/os-release | cut -d '=' -f2 | tr -d '"' | tr -d '.')
  37. if [[ "${release}" == "arch" ]]; then
  38. echo "Your OS is Arch Linux"
  39. elif [[ "${release}" == "parch" ]]; then
  40. echo "Your OS is Parch Linux"
  41. elif [[ "${release}" == "manjaro" ]]; then
  42. echo "Your OS is Manjaro"
  43. elif [[ "${release}" == "armbian" ]]; then
  44. echo "Your OS is Armbian"
  45. elif [[ "${release}" == "alpine" ]]; then
  46. echo "Your OS is Alpine Linux"
  47. elif [[ "${release}" == "opensuse-tumbleweed" ]]; then
  48. echo "Your OS is OpenSUSE Tumbleweed"
  49. elif [[ "${release}" == "openEuler" ]]; then
  50. if [[ ${os_version} -lt 2203 ]]; then
  51. echo -e "${red} Please use OpenEuler 22.03 or higher ${plain}\n" && exit 1
  52. fi
  53. elif [[ "${release}" == "centos" ]]; then
  54. if [[ ${os_version} -lt 8 ]]; then
  55. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  56. fi
  57. elif [[ "${release}" == "ubuntu" ]]; then
  58. if [[ ${os_version} -lt 2004 ]]; then
  59. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  60. fi
  61. elif [[ "${release}" == "fedora" ]]; then
  62. if [[ ${os_version} -lt 36 ]]; then
  63. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  64. fi
  65. elif [[ "${release}" == "amzn" ]]; then
  66. if [[ ${os_version} != "2023" ]]; then
  67. echo -e "${red} Please use Amazon Linux 2023!${plain}\n" && exit 1
  68. fi
  69. elif [[ "${release}" == "debian" ]]; then
  70. if [[ ${os_version} -lt 11 ]]; then
  71. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  72. fi
  73. elif [[ "${release}" == "almalinux" ]]; then
  74. if [[ ${os_version} -lt 80 ]]; then
  75. echo -e "${red} Please use AlmaLinux 8.0 or higher ${plain}\n" && exit 1
  76. fi
  77. elif [[ "${release}" == "rocky" ]]; then
  78. if [[ ${os_version} -lt 8 ]]; then
  79. echo -e "${red} Please use Rocky Linux 8 or higher ${plain}\n" && exit 1
  80. fi
  81. elif [[ "${release}" == "ol" ]]; then
  82. if [[ ${os_version} -lt 8 ]]; then
  83. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  84. fi
  85. else
  86. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  87. echo "Please ensure you are using one of the following supported operating systems:"
  88. echo "- Ubuntu 20.04+"
  89. echo "- Debian 11+"
  90. echo "- CentOS 8+"
  91. echo "- OpenEuler 22.03+"
  92. echo "- Fedora 36+"
  93. echo "- Arch Linux"
  94. echo "- Parch Linux"
  95. echo "- Manjaro"
  96. echo "- Armbian"
  97. echo "- AlmaLinux 8.0+"
  98. echo "- Rocky Linux 8+"
  99. echo "- Oracle Linux 8+"
  100. echo "- OpenSUSE Tumbleweed"
  101. echo "- Amazon Linux 2023"
  102. exit 1
  103. fi
  104. install_base() {
  105. case "${release}" in
  106. ubuntu | debian | armbian)
  107. apt-get update && apt-get install -y -q wget curl tar tzdata
  108. ;;
  109. centos | almalinux | rocky | ol)
  110. yum -y update && yum install -y -q wget curl tar tzdata
  111. ;;
  112. fedora | amzn)
  113. dnf -y update && dnf install -y -q wget curl tar tzdata
  114. ;;
  115. arch | manjaro | parch)
  116. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  117. ;;
  118. opensuse-tumbleweed)
  119. zypper refresh && zypper -q install -y wget curl tar timezone
  120. ;;
  121. *)
  122. apt-get update && apt install -y -q wget curl tar tzdata
  123. ;;
  124. esac
  125. }
  126. gen_random_string() {
  127. local length="$1"
  128. local random_string=$(LC_ALL=C tr -dc 'a-zA-Z0-9' </dev/urandom | fold -w "$length" | head -n 1)
  129. echo "$random_string"
  130. }
  131. config_after_install() {
  132. local existing_username=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'username: .+' | awk '{print $2}')
  133. local existing_password=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'password: .+' | awk '{print $2}')
  134. local existing_webBasePath=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'webBasePath: .+' | awk '{print $2}')
  135. local existing_port=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'port: .+' | awk '{print $2}')
  136. local server_ip=$(curl -s https://api.ipify.org)
  137. if [[ ${#existing_webBasePath} -lt 4 ]]; then
  138. if [[ "$existing_username" == "admin" && "$existing_password" == "admin" ]]; then
  139. local config_webBasePath=$(gen_random_string 15)
  140. local config_username=$(gen_random_string 10)
  141. local config_password=$(gen_random_string 10)
  142. read -p "Would you like to customize the Panel Port settings? (If not, a random port will be applied) [y/n]: " config_confirm
  143. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  144. read -p "Please set up the panel port: " config_port
  145. echo -e "${yellow}Your Panel Port is: ${config_port}${plain}"
  146. else
  147. local config_port=$(shuf -i 1024-62000 -n 1)
  148. echo -e "${yellow}Generated random port: ${config_port}${plain}"
  149. fi
  150. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}" -port "${config_port}" -webBasePath "${config_webBasePath}"
  151. echo -e "This is a fresh installation, generating random login info for security concerns:"
  152. echo -e "###############################################"
  153. echo -e "${green}Username: ${config_username}${plain}"
  154. echo -e "${green}Password: ${config_password}${plain}"
  155. echo -e "${green}Port: ${config_port}${plain}"
  156. echo -e "${green}WebBasePath: ${config_webBasePath}${plain}"
  157. echo -e "${green}Access URL: http://${server_ip}:${config_port}/${config_webBasePath}${plain}"
  158. echo -e "###############################################"
  159. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  160. else
  161. local config_webBasePath=$(gen_random_string 15)
  162. echo -e "${yellow}WebBasePath is missing or too short. Generating a new one...${plain}"
  163. /usr/local/x-ui/x-ui setting -webBasePath "${config_webBasePath}"
  164. echo -e "${green}New WebBasePath: ${config_webBasePath}${plain}"
  165. echo -e "${green}Access URL: http://${server_ip}:${existing_port}/${config_webBasePath}${plain}"
  166. fi
  167. else
  168. if [[ "$existing_username" == "admin" && "$existing_password" == "admin" ]]; then
  169. local config_username=$(gen_random_string 10)
  170. local config_password=$(gen_random_string 10)
  171. echo -e "${yellow}Default credentials detected. Security update required...${plain}"
  172. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}"
  173. echo -e "Generated new random login credentials:"
  174. echo -e "###############################################"
  175. echo -e "${green}Username: ${config_username}${plain}"
  176. echo -e "${green}Password: ${config_password}${plain}"
  177. echo -e "###############################################"
  178. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  179. else
  180. echo -e "${green}Username, Password, and WebBasePath are properly set. Exiting...${plain}"
  181. fi
  182. fi
  183. /usr/local/x-ui/x-ui migrate
  184. }
  185. install_x-ui() {
  186. cd /usr/local/
  187. if [ $# == 0 ]; then
  188. tag_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  189. if [[ ! -n "$tag_version" ]]; then
  190. echo -e "${red}Failed to fetch x-ui version, it may be due to GitHub API restrictions, please try it later${plain}"
  191. exit 1
  192. fi
  193. echo -e "Got x-ui latest version: ${tag_version}, beginning the installation..."
  194. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz
  195. if [[ $? -ne 0 ]]; then
  196. echo -e "${red}Downloading x-ui failed, please be sure that your server can access GitHub ${plain}"
  197. exit 1
  198. fi
  199. else
  200. tag_version=$1
  201. tag_version_numeric=${tag_version#v}
  202. min_version="2.3.5"
  203. if [[ "$(printf '%s\n' "$min_version" "$tag_version_numeric" | sort -V | head -n1)" != "$min_version" ]]; then
  204. echo -e "${red}Please use a newer version (at least v2.3.5). Exiting installation.${plain}"
  205. exit 1
  206. fi
  207. url="https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz"
  208. echo -e "Beginning to install x-ui $1"
  209. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  210. if [[ $? -ne 0 ]]; then
  211. echo -e "${red}Download x-ui $1 failed, please check if the version exists ${plain}"
  212. exit 1
  213. fi
  214. fi
  215. if [[ -e /usr/local/x-ui/ ]]; then
  216. systemctl stop x-ui
  217. rm /usr/local/x-ui/ -rf
  218. fi
  219. tar zxvf x-ui-linux-$(arch).tar.gz
  220. rm x-ui-linux-$(arch).tar.gz -f
  221. cd x-ui
  222. chmod +x x-ui
  223. # Check the system's architecture and rename the file accordingly
  224. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  225. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  226. chmod +x bin/xray-linux-arm
  227. fi
  228. chmod +x x-ui bin/xray-linux-$(arch)
  229. cp -f x-ui.service /etc/systemd/system/
  230. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  231. chmod +x /usr/local/x-ui/x-ui.sh
  232. chmod +x /usr/bin/x-ui
  233. config_after_install
  234. systemctl daemon-reload
  235. systemctl enable x-ui
  236. systemctl start x-ui
  237. echo -e "${green}x-ui ${tag_version}${plain} installation finished, it is running now..."
  238. echo -e ""
  239. echo -e "┌───────────────────────────────────────────────────────┐
  240. │ ${blue}x-ui control menu usages (subcommands):${plain} │
  241. │ │
  242. │ ${blue}x-ui${plain} - Admin Management Script │
  243. │ ${blue}x-ui start${plain} - Start │
  244. │ ${blue}x-ui stop${plain} - Stop │
  245. │ ${blue}x-ui restart${plain} - Restart │
  246. │ ${blue}x-ui status${plain} - Current Status │
  247. │ ${blue}x-ui settings${plain} - Current Settings │
  248. │ ${blue}x-ui enable${plain} - Enable Autostart on OS Startup │
  249. │ ${blue}x-ui disable${plain} - Disable Autostart on OS Startup │
  250. │ ${blue}x-ui log${plain} - Check logs │
  251. │ ${blue}x-ui banlog${plain} - Check Fail2ban ban logs │
  252. │ ${blue}x-ui update${plain} - Update │
  253. │ ${blue}x-ui legacy${plain} - legacy version │
  254. │ ${blue}x-ui install${plain} - Install │
  255. │ ${blue}x-ui uninstall${plain} - Uninstall │
  256. └───────────────────────────────────────────────────────┘"
  257. }
  258. echo -e "${green}Running...${plain}"
  259. install_base
  260. install_x-ui $1